#include "insertion-sort.h"
#include <iostream>

using namespace std;

void insertion_sort_cosort(int n, double* x, double* y)
{
   if((n < 1) || (x == NULL)) return;

   double sortedx[n];  // integer array with n elements in local memory
   double cosortedy[n];  // will only be used if y is not NULL

   for(int i = 0; i < n; i++)
   {
      // at this point, elements sortedx[0] to sortedx[i-1] are in use;
      // by the end of this loop iteration, sortedx[0] to sortedx[i]
      // will be used
      //
      // values from x[0] to x[i-1] have already been inserted; now
      // find the right position for inserting x[i], the next value
      //
      int j = 0;
      while((j < i) && (sortedx[j] < x[i])) j++;

      // shift values from sortedx[j] onward to make space for x[i];
      // before, the indices 0 to i-1 were in use; afterwards, 0 to i
      //
      for(int k = i; k > j; k = k - 1)
      {
         sortedx[k] = sortedx[k-1];
         if(y != NULL) cosortedy[k] = cosortedy[k-1];  // accordingly, for y
      }

      // now insert the new value, x[i], at position sortedx[j]
      //
      sortedx[j] = x[i];
      if(y != NULL) cosortedy[j] = y[i];  // accordingly, for y
   }

   // now overwrite the array x with its sorted version and return
   //
   for(int i = 0; i < n; i++)
   {
      x[i] = sortedx[i];
      if(y != NULL) y[i] = cosortedy[i];  // accordingly, for y
   }
   return;
}

void insertion_sort(int n, double* x)
{
   if((n < 1) || (x == NULL)) return;

   insertion_sort_cosort(n, x, NULL);
   return;
}

